#ifndef WAVEIO_H_INCLUDED
#define WAVEIO_H_INCLUDED

#include "audio_params.h"

#define     WAVEIN_CHANNELS             1 // number of channels for input
#define     WAVEIN_FS                   ((u32)SampleRate) // Wave In Sample rate (Hz)
#define     WAVEIN_BUFFER_LENGTH        (BufferSize*2*WAVEIN_CHANNELS)
#define     WAVEIN_SAMPLES_PER_BUFFER   BufferSize
#define     WAVEIN_BYTES_PER_SAMPLE     (2*WAVEIN_CHANNELS)
#define     WAVEIN_NUM_OF_BUFFERS       5    // No less then 3!

#define     WAVEOUT_CHANNELS             1 // number of channels for output
#define     WAVEOUT_FS                   ((u32)SampleRate) // Wave Out Sample rate (Hz)
//#define     WAVEOUT_BUFFER_LENGTH        (BufferSize*2*WAVEOUT_CHANNELS)
#define     WAVEOUT_SAMPLES_PER_BUFFER   BufferSize
//#define     WAVEOUT_BYTES_PER_SAMPLE     (2*WAVEOUT_CHANNELS)
#define     WAVEOUT_NUM_OF_BUFFERS       5    // No less then 3!
  
#include <windows.h>
#include <windowsx.h>
#include <mmsystem.h>
#include <string.h>

class WAVEIN
{
WAVEFORMATEX waveformatex;
HWAVEIN  hwi;
LPSTR wi_data[WAVEIN_NUM_OF_BUFFERS];
WAVEHDR wi[WAVEIN_NUM_OF_BUFFERS];
int wavein_buffer_id;

protected:

CRITICAL_SECTION cswi;

int wavein_flag;

friend void CALLBACK waveInProc(HWAVEIN hwi,UINT uMsg,DWORD dwInstance,DWORD dwParam1,DWORD dwParam2);     

public:
 WAVEIN(UINT waveInDevID = WAVE_MAPPER);		// Create waveIn with number waveInDevID
 ~WAVEIN();
    
 char *GetBuffer(void);  // NULL = not ready, otherwise returns pointer
 HANDLE rxEvent;					// Event signalling what buffer full

 HWAVEIN GetWaveInHandle(void) {return hwi;};
};



class WAVEOUT
{
WAVEFORMATEX waveformatex;
HWAVEOUT hwo;
LPSTR wh_data[WAVEOUT_NUM_OF_BUFFERS];
WAVEHDR wh[WAVEOUT_NUM_OF_BUFFERS];
int waveout_buffer_id;
u32 bufferSizeBytes;

protected:

CRITICAL_SECTION cswo;

int waveout_flag; 

friend void CALLBACK waveOutProc(HWAVEOUT hwo,UINT uMsg,DWORD dwInstance,DWORD dwParam1,DWORD dwParam2);

public:
 WAVEOUT(UINT waveOutDevID = WAVE_MAPPER, UINT channels = WAVEOUT_CHANNELS, int fs = WAVEOUT_FS, UINT bufferSize = WAVEOUT_SAMPLES_PER_BUFFER);
 ~WAVEOUT();

 u32 GetBufferSizeBytes(void) {return bufferSizeBytes;};
 char *GetBuffer(void); // NULL = not ready, otherwise returns pointer
 HANDLE txEvent;					// Event signalling what buffer full

 HWAVEOUT GetWaveOutHandle(void) {return hwo;};
};

#endif
