#ifndef XTEA_H_INCLUDED
#define XTEA_H_INCLUDED

#include "types.h"

void XTEA_Encode(u32* v, u32 const* k);
void XTEA_Decode(u32* v, u32 const* k);

// Block XTEA is weaker then XXTEA

void Block_XTEA_Encode(u32 *v, const u32 n, u32 const* k, const u32 rounds = 0);
void Block_XTEA_Decode(u32 *v, const u32 n, u32 const* k, const u32 rounds = 0);

void XXTEA_Encode(u32 *v, const u32 n, u32 const* k, const u32 rounds = 0);
void XXTEA_Decode(u32 *v, const u32 n, u32 const* k, const u32 rounds = 0);


//#define TEST_XTEA

#ifdef TEST_XTEA

void tean(long * v, long * k, long N); // XTEA
long teab( long * v, long n , long * k ); // block XTEA
long btea( long * v, long n , long * k ); // block XXTEA


#endif // TEST_XTEA
#endif
