#ifndef CONTROL_H
#define CONTROL_H

#include "network.h"

typedef struct MESSAGE_STR{
    TCHAR* text;
    u32 msg_num;
    u32 send_cnt;
    struct MESSAGE_STR* next;
} MESSAGE;

enum {
    CTRL_ST_IDLE,
    CTRL_ST_CONNECTION,
    CTRL_ST_CONNECTED,
    CTRL_ST_DIALING,
    CTRL_ST_IN_VOICE,
    CTRL_ST_HOLD,
    CTRL_ST_LAST
};

static const u32 CONTR_MAX_VOICE_BUF = 5;

class CONTR_PROT {
	HWND mainWnd;
	HWND parent;
    u32 state;
    MESSAGE* msg;
    u32 send_msg_num;
    u32 rec_msg_num;
    u32 rec_msg_flag;
    u32 voice_cnt;
	u32* send_voice_buf;

    void processMessages(void);

public:
    CONTR_PROT(NODE* node, HWND mWnd, HWND parent);
    ~CONTR_PROT();
    NODE nd;
    u8* rec_data[CONTR_MAX_VOICE_BUF];
    u32 rec_size[CONTR_MAX_VOICE_BUF];
    void sendMessage(TCHAR* message);
    void sendVoice(u8* data, u32 size);
    u8* getVoice(u32* size);
    void dial(void);
    void process(void);
    void received(u32* packet, u32 size);
    u32 getState(void) {return state;}
    bool isPendingMessages(void) {return msg != NULL;}
};

#endif // CONTROL_H
