#ifndef CP_STROP_H_INCLUDED
#define CP_STROP_H_INCLUDED
//---------------------------------------------------------------------------
#if !defined(_WIN32) && !defined(_LINUX)
#error "OS not specified!"
#endif
//---------------------------------------------------------------------------
#include <string.h>
#include <locale.h>
#include "types.h"
//---------------------------------------------------------------------------
#ifdef _LINUX
#include <stdio.h>
#include <wchar.h>
#include <time.h>

#ifdef _UNICODE
#define _T(a) L##a
#else
#define _T(a) a
#endif

#define cp_printf		printf
#define cp_scanf		scanf

#define cp_snprintf		snprintf
#define cp_vsnprintf	vsnprintf
#define cp_sscanf		sscanf

#define cp_sscanfA		sscanf
#define cp_sscanfW		swscanf

#define cp_snprintfA	snprintf
#define cp_snprintfW	swprintf

#define cp_vsnprintfA	vsnprintf
#define cp_vsnprintfW	vswprintf

#define cp_strlen		strlen
#define cp_strstr		strstr
#define cp_strchr		strchr
#define cp_strrchr		strrchr
#define cp_strcmp		strcmp
#define cp_stricmp		strcasecmp
#define cp_strncmp		strncmp
#define cp_strnicmp		strncasecmp
#define cp_strtok		strtok_r

#define cp_strncmpA		strncmp
#define cp_strncmpW		wcsncmp

#define cp_strtokA		strtok_r
#define cp_strtokW		wcstok_r

#define cp_strncpy		strncpy
#define cp_strncat		strncat

#define cp_strcbcpyA	cp_strcchcpyA
#define cp_strcbcpyW(d,n,s)	cp_strcchcpyW((d),(n)/2,(s))
#define cp_strcbcpy		cp_strcbcpyA

#define cp_strcchcpyA(d,n,s) strncpy((d),(s),(n)),(d)[(n)-1]=0
#define cp_strcchcpyW(d,n,s) wcsncpy((d),(s),(n)),(d)[(n)-1]=0
#define cp_strcchcpy	cp_strcchcpyA

#define cp_strcbcatA	cp_strcchcatA
#define cp_strcbcatW(d,n,s)	cp_strcchcatW((d),(n)/2,(s))
#define cp_strcbcat		cp_strcbcatA

#define cp_strcchcatA(d,n,s) strncat((d),(s),(n)),d[(n)-1]=0
#define cp_strcchcatW(d,n,s) wcsncat((d),(s),(n)),d[(n)-1]=0
#define cp_strcchcat	cp_strcbcat

#define cp_localtime(r,t)	localtime_r(t,r)
#define cp_strftime		strftime

#define cp_strerror		strerror

#define SPF_ERR_BUFF(f,n)	((f) > (int)(n))

#elif defined(_WIN32)

#include <windows.h>
#include <tchar.h>
#include <strsafe.h>

#define cp_printf		_tprintf_s
#define cp_scanf		_tscanf_s

#define cp_snprintfA	StringCchPrintfA
#define cp_snprintfW	StringCchPrintfW
#define cp_snprintf		StringCchPrintf

#define cp_vsnprintfA	StringCchVPrintfA
#define cp_vsnprintfW	StringCchVPrintfW
#define cp_vsnprintf	StringCchVPrintf

#define cp_sscanf		_stscanf_s

#define cp_sscanfA		sscanf_s
#define cp_sscanfW		swscanf_s

#define cp_strlen		_tcslen
#define cp_strstr		_tcsstr
#define cp_strchr		_tcschr
#define cp_strrchr		_tcsrchr
#define cp_strcmp		_tcscmp
#define cp_stricmp		_tcsicmp
#define cp_strncmp		_tcsncmp
#define cp_strnicmp		_tcsnicmp
#define cp_strtok		_tcstok_s

#define cp_strncmpA		strncmp
#define cp_strncmpW		wcsncmp

#define cp_strtokA		strtok_s
#define cp_strtokW		wcstok_s

#define cp_strcpy		_tcscpy
#define cp_strncpy		_tcsncpy
#define cp_strncat		_tcsncat

#define cp_strcbcpyA	StringCbCopyA
#define cp_strcbcpyW	StringCbCopyW
#define cp_strcbcpy		StringCbCopy

#define cp_strcchcpyA	StringCchCopyA
#define cp_strcchcpyW	StringCchCopyW
#define cp_strcchcpy	StringCchCopy

#define cp_strcbcatA	StringCbCatA
#define cp_strcbcatW	StringCbCatW
#define cp_strcbcat		StringCbCat

#define cp_strcchcatA	StringCchCatA
#define cp_strcchcatW	StringCchCatW
#define cp_strcchcat	StringCchCat

#define cp_localtime	localtime_s
#define cp_strftime		_tcsftime

#define cp_strerror		_tcserror

#define SPF_ERR_BUFF(f,n)	((f) == STRSAFE_E_INSUFFICIENT_BUFFER)

#endif
//---------------------------------------------------------------------------
#define cp_printfA		printf
#define cp_printfW		wprintf

#define cp_scanfA		scanf
#define cp_scanfW		wscanf

#define cp_strlenA		strlen
#define cp_strlenW		wcslen

#define cp_strncpyA		strncpy
#define cp_strncpyW		wcsncpy

#define cp_strncatA		strncat
#define cp_strncatW		wcsncat

#define cp_strstrA		strstr
#define cp_strstrW		wcsstr

#define cp_strchrA		strchr
#define cp_strchrW		wcschr

#define cp_strcmpA		strcmp
#define cp_strcmpW		wcscmp

#define cp_stricmpA		stricmp
#define cp_stricmpW		wcsicmp

#define cp_strftimeA	strftime
#define cp_strftimeW	wcsftime

#define cp_strerrorA	strerror
#define cp_strerrorW	_wcserror
//---------------------------------------------------------------------------
#define _CCH(v)			sizeof(v)/sizeof(tchar_t)
#define _SZ(v)			sizeof(v)/sizeof(*v)
//----------------------------------------------------------------------------------
#endif //CP_STROP_H_INCLUDED
